Package org.bgerp.app.cfg

# Class Config

java.lang.Object
org.bgerp.app.cfg.Config

Direct Known Subclasses:
  `BoardConfig`, `BoardsConfig`, `CalendarConfig`, `CallboardConfig`, `CallboardPlanConfig`, `CallboardTabelConfig`, `CategoryConfig`, `Config`, `Config`, `Config`, `Config`, `Config`, `Config`, `Config`, `Config`, `Config`, `Config`, `Config`, `Config`, `Config`, `Config`, `Config`, `Config`, `Config`, `Config`, `ContractTypesConfig`, `DayTypeConfig`, `DefaultMarkedProcessor.Config`, `GMS`, `IsolationConfig`, `LdapAuthConfig`, `ListParamConfig`, `MessageAction.Config`, `MessagePossibleProcessConfig`, `MessageTypeConfig`, `NumberProvider`, `PaidInvoiceConfig`, `PositionProvider`, `PrintQueueConfig`, `ProcessAction.Config`, `ProcessCardConfig`, `ProcessCreateInConfig`, `ProcessCreateLinkConfig`, `ProcessCreateLinkItem`, `ProcessDescriptionConfig`, `ProcessLinkCategory`, `ProcessLinkCategoryConfig`, `ProcessLinkModesConfig`, `ProcessNotificationConfig`, `ProcessPriorityConfig`, `ProcessQueueAction.Config`, `ProcessTimeSetConfig`, `ProcessTitleConfig`, `ProcessTypeConfig`, `ProcessTypeConfig`, `ProcessTypeConfig`, `ProfileAction.Config`, `RecipientsConfig`, `RegexpCheckerConfig`, `RowExpressionConfig`, `SavedFiltersConfig`, `SavedPanelConfig`, `Sender`, `ShiftConfig`, `ShortcutConfig`, `TagConfig`, `Task`, `TasksConfig`, `TemplateConfig`

public abstract class Config extends Object
Configuration, created on demand in `ConfigMap.getConfig(Class)` and cached before it has changed.

- ## Nested Class Summary

  Nested Classes
  Modifier and Type
  Class
  Description
  `static class`
  `Config.InitStopException`
  The exception, thrown on empty configuration.

- ## Field Summary

  Fields
  Modifier and Type
  Field
  Description
  `static final Config`
  `EMPTY`
  `protected static final Log`
  `log`

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `Config(ConfigMap config)`
  The constructor has to be overwritten and implement parameters parsing.
  `protected`
  `Config(ConfigMap config, boolean validate)`
  The constructor has to be overwritten and implement parameters parsing.

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected void`
  `initWhen(boolean criteria)`
  Check, is the configuration initialized.
  `protected void`
  `throwValidationException(String message, Object... args)`
  Throws validation exception.

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Field Details

  - ### log

    protected static final Log log

  - ### EMPTY

    public static final Config EMPTY

- ## Constructor Details

  - ### Config

    protected Config(ConfigMap config)
    The constructor has to be overwritten and implement parameters parsing. Simple constructor, without deprecated keys validation support.
    Parameters:
      `config` - configuration, MUST be `null` when calling `super`.

  - ### Config

    protected Config(ConfigMap config, boolean validate)
    The constructor has to be overwritten and implement parameters parsing.
    Parameters:
      `config` - configuration, MUST be `null` when calling `super`.
      `validate` - validation old configuration keys.

- ## Method Details

  - ### initWhen

    protected void initWhen(boolean criteria) throws Config.InitStopException
    Check, is the configuration initialized.
    Parameters:
      `criteria` -
    Throws:
      `Config.InitStopException` - if is false.

  - ### throwValidationException

    protected void throwValidationException(String message, Object... args) throws BGMessageException
    Throws validation exception.
    Parameters:
      `message` -
      `args` -
    Throws:
      `BGMessageException`